#include <iostream>
#include <fstream>
#include <iomanip>
#include <vector>
#include <map>
#include <set>

using namespace std;

const int MAXN = 1002;

int field[MAXN][MAXN];

struct queue_max{
    int l, r;
    int a[MAXN];

    queue_max() : l(0), r(0){};

    bool empty() const {
        return l == r;
    }
    void push(int x){
        while(!empty() && a[r - 1] < x)
            r--;
        a[r] = x;
        r++;
    }
    int getmax() const{
        return a[l];
    }

    void pop(int x) {
        if(a[l] == x)
            l++;
    }
    void clear() {
        l = 0;
        r = 0;
    }
};

int check(int n, int a, int b){
    queue_max qm[n];
    queue_max qv;
    for(int i = 0; i < n; i++){
        for(int j = 0; j + 1 < a; j++){
                qm[i].push(field[i][j]);
        }
    }
    int min_ans = n*n;
    for(int j = a - 1; j < n; j++){
        for(int i = 0; i < n; i++)
            qm[i].push(field[i][j]);

        qv.clear();

        for(int i = 0; i + 1 < b; i++)
            qv.push(qm[i].getmax());
        for(int i = b - 1; i < n; i++){
            qv.push(qm[i].getmax());

            min_ans = min(min_ans, qv.getmax());

            qv.pop(qm[i - b + 1].getmax());
        }

        for(int i = 0; i < n; i++)
            qm[i].pop(field[i][j - a + 1]);

    }
    return min_ans;
}


int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);

    int n, a, b;
    cin >> n >> a >> b;

    for(int i = 0; i < n; i++)
        for(int j = 0; j < n; j++)
            cin >> field[i][j];

    cout << min(check(n, a, b),
                check(n, b, a));

    return 0;
}

/*
5 2 3
3 13 14 15 18
20 11 7 10 16
12 2 4 8 17
5 9 6 19 1
21 24 25 23 22
*/
